# written 2007 by Charlie Shepherd
# License: GPL-2


def unstable(keywords, arch):
    pos = keywords.find(arch)
    if pos == -1:
        raise IndexError(keywords, arch)
    if pos != 0 and keywords[pos-1] == '~':
        return keywords
    return "%s~%s" % (keywords[:pos].rstrip('-'), keywords[pos:])

def stable(keywords, arch):
    pos = keywords.find(arch)
    if pos == -1:
        raise IndexError(keywords, arch)
    if pos != 0 and keywords[pos-1] not in ('~', '-'):
        return keywords
    return "%s%s" % (keywords[:pos-1], keywords[pos:])

def negate(keywords, arch):
    pos = keywords.find(arch)
    if pos == -1:
        raise IndexError(keywords, arch)
    if pos != 0 and keywords[pos-1] == '-':
        return keywords
    return "%s-%s" % (keywords[:pos].rstrip('~'), keywords[pos:])

def remove(keywords, arch):
    pos = keywords.find(arch)
    if pos == -1:
        raise IndexError(keywords, arch)
    if pos != 0 and keywords[pos-1] in ('~', '-'):
        string = "%s%s" % (keywords[pos-1], arch)
    else:
        string = arch
    return keywords.replace(string, "")


actions = {
    '~': unstable,
    '^': remove,
    '-': negate,
}

def get_keywords(filename):
    l = []
    for i, x in enumerate(open(filename).readlines()):
        if x.startswith("KEYWORDS=\""):
            l.append(x.strip())
    if not l:
        raise IndexError(filename)
    keywords = l[-1]
    if keywords.find('$') != -1:
        raise NotImplementedError(keywords)
    return keywords[10:-1], i

def do_keyword(arch, ebuild):
    keywords, line = get_keywords(ebuild)
    if arch.lstrip('-^~') == 'all':
        if not arch[0].isalnum():
            s = arch[0]
        else:
            s = ""
        arches = tuple("%s%s" % (s, x.lstrip('~-')) for x in keywords.split(' '))
    else:
        arches = (arch,)
    for arch in arches:
        if arch[0].isalnum():
            action = stable
        else:
            action = actions[arch[0]]
            arch = arch[1:]
        keywords = action(keywords, arch)
    print keywords
    l = open(ebuild).readlines()
    for i, x in enumerate(l):
        if x.startswith("KEYWORDS=\""):
            l[i] = "KEYWORDS=\"%s\"\n" % keywords
    open(ebuild, 'w').writelines(l)
