# (c) 2007 by Markus Ullmann
# License: GPL-2


"""all default action buttons are handled here"""


from PyQt4 import QtGui
from maintainer_helper.gui.version_bump import version_bump_widget
from maintainer_helper.gui.drop_version import drop_version_widget
from snakeoil.osutils import pjoin

from maintainer_helper.backend.tasks import edit


class default_actions(object):
    """grouping into one class for now"""

    def __init__(self, parent):
        """store the reference to the ui

        @param parent: the window we work on (from core.py)
        """

        self.parent = parent
        self.useriface = parent.useriface

    def do_edit(self, toggle):
        """call editor on selected version
        """

        row = self.useriface.keywordBox.currentRow()
        (category, package) = self.parent.get_packagetree_entry()
        version = str(self.useriface.keywordBox.verticalHeaderItem(
            row).text()).encode('ascii')

        ebuildfile = pjoin(self.parent.domain_repo_interface.work_repo_location,
            category, package, package + "-" + version + ".ebuild")
        edit(ebuildfile)

    def do_edit_pmask(self, toggle):
        """call editor for editing package.mask on selected
        repository. hardcoded vi for now, can be improved later
        """

        pmaskfile = pjoin(self.parent.domain_repo_interface.work_repo_location,
            "profiles", "package.mask")
        edit(pmaskfile)

    def do_version_bump(self, toggle):
        """version bump was clicked

        @param toggle: check or not, not used"""

        atom = self.parent.get_packagetree_entry()
        if atom is None:
            QtGui.QMessageBox.critical(self.parent,
                "No package selected",
                "Please select a package to bump")
            return

        version_bump_widget(self.parent)

    def do_ebuild_bump(self, toggle):
        """version bump was clicked

        @param toggle: check or not, not used"""

        version = self.parent.get_current_version()

        version_bump_widget(self.parent, version)

    def do_drop_version(self, toggle):
        """drop version was clicked

        @param toggle: check or not, not used"""

        drop_version_widget(self.parent)
