#!/usr/bin/python

# (c) 2006 by Markus Ullmann
# License: GPL-2

import os, sys, time

from PyQt4 import QtGui, QtCore
from RevdepDialog_ui import Ui_Dialog
from pkgcore.restrictions import packages
from RevdepBuilder import RevdepBuilder


class RevdepMainWidget(QtGui.QDialog):
    def __init__(self, parent):
        QtGui.QDialog.__init__(self, parent)

	self.parent = parent
        self.ui = Ui_Dialog()
        self.ui.setupUi(self)

        self.workthread = RevdepBuilder()
        
        self.connect(self.ui.nextbutton,
            QtCore.SIGNAL("clicked()"),
            self.goForIt)
        self.connect(self.workthread,
            QtCore.SIGNAL("stepUpdate(int)"),
            self.setGuiStatus)
        self.connect(self.workthread,
            QtCore.SIGNAL("setMaxCount(int)"),
            self.setMaxBar)
        self.connect(self.workthread,
            QtCore.SIGNAL("setCount(int)"),
            self.ui.currentStepProgress.setValue)
        self.connect(self.ui.selectDB,
            QtCore.SIGNAL("clicked()"),
            self.selectDB)
        self.connect(self.ui.selectedDBFile,
            QtCore.SIGNAL("textChanged(QString)"),
            self.checkDBFile)

        self.ui.repoSelect.addItems(self.workthread.getRepoList())
        self.show()

    def selectDB(self):
        if self.ui.updateExistingDB.isChecked():
            self.ui.selectedDBFile.setText(
                QtGui.QFileDialog.getOpenFileName(self,
                    "Open existing database", "","Databases (*.pdb)"))
        else:
            self.ui.selectedDBFile.setText(
                QtGui.QFileDialog.getSaveFileName(self,
                    "Create new database", "","Databases (*.pdb)"))

    def checkDBFile(self,filename):
        if len(filename) > 0:
            if filename[-4:] != ".pdb":
                self.ui.selectedDBFile.setText("%s.pdb" % filename)
            self.ui.nextbutton.setEnabled(True)
        else:
            self.ui.nextbutton.setEnabled(False)

    def goForIt(self):
        self.setGuiStatus(1)
        self.workthread.setRepo(self.ui.repoSelect.currentIndex())
        self.workthread.setDB(self.ui.updateExistingDB.isChecked(),
                              str(self.ui.selectedDBFile.text()))
        self.workthread.start()
 
    def setGuiStatus(self,step):
        if step == 1:
            self.ui.groupDB.setEnabled(False)
            self.ui.groupRepo.setEnabled(False)
            self.ui.nextbutton.setEnabled(False)
            self.ui.nextbutton.setText("Running...")
        elif step == 2:
            self.ui.listBuilt.setChecked(True)
        elif step == 3:
            self.ui.currentStepProgress.setValue(0)
        elif step == 4:
            self.ui.builtRevDeps.setChecked(True)
            self.ui.currentStepProgress.setEnabled(False)
            self.ui.currentStepProgress.setValue(0)
            self.ui.currentStepProgress.setRange(0,0)
        elif step == 5:
            self.ui.nextbutton.setText("Done")
    	    self.disconnect(self.ui.nextbutton,
        	QtCore.SIGNAL("clicked()"),
        	self.goForIt)
            self.connect(self.ui.nextbutton,
	        QtCore.SIGNAL("clicked()"),
    	        self.accept)
            self.ui.nextbutton.setEnabled(True)


    def setMaxBar(self,max):
        self.ui.currentStepProgress.setEnabled(True)
        self.ui.currentStepProgress.setRange(0,max)
